hirom
header					; comment out header for unheadered ROMs

!tabledata = $F30000	; 4 tables, 472($1D8) bytes needed for block
!descriptions = $F30400	; pointers and data, 1713($6B1) bytes needed for block
!freespaceC0 = $C0D613 	; 2 function, 75($4B) bytes needed for block
!freespaceC2 = $C267C0	; 1 function, 64($40) bytes needed for block
!freespaceC3 = $C3F2F0	; 2 functions, 198($C6) bytes needed for block
!freespaceF3 = $F301E0	; 13 functions, 515($203) bytes needed for block

; apply patch to an expanded FF3us 1.0 ROM.
; code with (X) in the description modifies vanilla code and should NOT be moved.
; code with <> in the description is independent of code outside this patch and is relocatable.

; <> spell list table (character properties ID -> spell list)
org !tabledata
SpellListTbl:
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$FF,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $0E,$0F,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F

; <> spell bit table (1st byte=offset, 2nd byte=bit to check)
org !tabledata+256
SpellByteTbl:
db $00
SpellBitTbl:
db $01,$00,$02,$00,$04,$00,$08,$00,$10,$00,$20,$00,$40,$00,$80
db $01,$01,$01,$02,$01,$04,$01,$08,$01,$10,$01,$20,$01,$40,$01,$80
db $02,$01,$02,$02,$02,$04,$02,$08,$02,$10,$02,$20,$02,$40,$02,$80
db $03,$01,$03,$02,$03,$04,$03,$08,$03,$10,$03,$20,$03,$40,$03,$80
db $04,$01,$04,$02,$04,$04,$04,$08,$04,$10,$04,$20,$04,$40,$04,$80
db $05,$01,$05,$02,$05,$04,$05,$08,$05,$10,$05,$20,$05,$40,$05,$80
db $06,$01,$06,$02,$06,$04,$06,$08,$06,$10,$06,$20,$06,$40,$06,$80
db $07,$01,$07,$02,$07,$04,$07,$08,$07,$10,$07,$20,$07,$40,$07,$80

; <> acutal spell table (what spell actually appears)
org !tabledata+384
SpellTbl:
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
db $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
db $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
db $30,$31,$32,$33,$34,$35,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

; <> bitmasks for determining what kind of magic each spell is
org !tabledata+448
BlackBitmask:			; black magic bitmask
db $FF,$FF,$FF,$00,$00,$00,$00,$00
GrayBitmask:			; gray magic bitmask
db $00,$00,$00,$FF,$FF,$1F,$00,$00 
WhiteBitmask:			; white magic bitmask
db $00,$00,$00,$00,$00,$E0,$3F,$00

; bitdata	 |01|	 |02|	|04|	|08|	|10|	|20|	|40|	|80|
; byte 0	(fire,	ice,	bolt,	poison,	drain,	fire2,	ice2,	bolt2)
; byte 1	(bio,	fire3,	ice3,	bolt3,	break,	doom,	pearl,	flare)
; byte 2	(demi,	quartr,	x-zone,	meteor,	ultima,	quake,	w wind,	merton)
; byte 3	(scan,	slow,	rasp,	mute,	safe,	sleep,	muddle,	haste)
; byte 4	(stop,	bserk,	float,	imp,	rflect,	shell,	vanish,	haste2)
; byte 5	(slow2,	osmose,	warp,	quick,	dispel,	cure,	cure2,	cure3)
; byte 6	(life,	life2,	antdot,	remedy,	regen,	life3,	NEW1,	NEW2)
; byte 7	(NEW3,	NEW4 ,	NEW5 ,	NEW6,	NEW7 ,	NEW8,	NEW9,	NEW10)

; <> spell description pointers and data
org !descriptions
SpellDescPntr:
incbin SpellDescPntr.bin
SpellDesc:
incbin SpellDesc.bin


; CO Bank changes

; (X) event command pointers
org $C09926
dw $AE0D				; pointer to C0/AE0D ("learn a spell" event command $66)

; (X) Fork: Terra's Spell list
org $C0A1A3
phx						; backup X
skip 4
nop #3					; wait
jsr LearnMagicC0()		; set spell as learned
plx						; restore X

; (X) Fork: Celes's Spell list
org $C0A1C5
phx						; backup X
skip 4
nop #3					; wait
jsr LearnMagicC0()		; set spell as learned
plx						; restore X

; (X) learn a spell, event command 66
org $C0AE12
lda #$23				; multiplier between lists
sta $4203				; save multiplier
rep #$21				; set 16-bit A, clear carry
lda #$1A89				; load starting address for all learned magic bits
nop	#2					; wait
adc $4216				; add the result of the multiplication
sta $12					; store spell list specific address
sep #$20				; 8-bit A
jsr LearnSpellC0_1()	; learn spell

; <> learn magic at character startup
org !freespaceC0
LearnMagicC0()
phy						; backup Y
php						; backup processor
pha						; backup spell number
lda $1600,Y				; load character ID
sep #$30				; set 8-bit A,X,Y
tax						; put character ID in X
lda SpellListTbl,X		; get characters spell list ID
sta $004202				; store multiplicand
lda #$23				; load spell list multiplier
sta $004203				; store multiplier
rep #$21				; set 16-bit A, clear carry
lda #$1A89				; load starting address for all magic lists
nop #2					; wait for processing to finish
adc $004216				; add offset to magic list for correct address
sta $12					; save magic list address
sep #$20				; set 8-bit A
tdc						; clear A
pla						; reload spell index
jsr LearnSpellC0_2()	; learn spell
plp						; restore processor
ply						; restore Y
rts						; exit

; <> learn spell (called from event 66 at C0/AE25 and learning magic at character startup at C0/D63A)
org !freespaceC0+46
LearnSpellC0_1()
tdc						; clear accumulator
lda $EC					; load another parameter, the spell number
LearnSpellC0_2()
phy						; backup Y (C0/D63A joins here)
jsl FindSpellIndex()	; find index for spell number
asl						; double the index
tax						; move doubled index to X
lda SpellBitTbl,X		; get bit to check in spell list
sta $10					; save bit to check in spell list
lda SpellByteTbl,X		; get byte offset
tay						; transfer byte offset to Y
lda ($12),Y				; load spell list with byte offset
ora $10					; set bit for our spell
sta ($12),Y				; save spell list byte
ply						; restore Y
rts						; exit


; C1 Bank Changes

; (X) offsets to character spell lists
org $C14B5F	
dw $0000				; relative pointer to $208E
dw $0164				; relative pointer to $21F2
dw $02C8				; relative pointer to $2356
dw $CD72				; relative pointer to $EE00

; (X) fixed lore availability address
org $C14D9B
lda $2192,Y				; load character-specific lore menu spell number
skip 3
lda $2193,Y				; load character-specific lore menu availability

; (X) fixed lore MP address
org $C158FA
lda $2195,X				; load lore MP cost

; (X) load letters for skean+ in text box display
org $C15FDD
jsl SkipSymbol_1()		; load letter, skipping magic symbols

; (X) display spell name in list
org $C1659B
jsl BackupAvailability(); backup availability

; (X) display spell name for skean attacks and onward in list
org $C165B6
jsl TrunkName()			; set name length based on current menu, retaining multiplier
skip 5
jsl SkeanName_C1()		; load spell name character

; (X) display spell name for esper attacks in list
org $C165D2
jsl TrunkName()			; set name length based on current menu, retaining multiplier
skip 5
jsl EsperName_C1()		; load spell name character

; (X) load letters for skean+ in text box display
org $C16AED
jsl SkipSymbol_2()		; load letter, skipping magic symbols

; (X) magic menu scrolling
org $C18178
cmp #$1C				; have we reached the end of the magic menu?

; (X) fixed lore menu address
org $C18364
lda $2193,X				; load lore availability
skip 4
lda $2192,X				; load lore spell number
skip 3
lda $2194,X				; load lore spell targeting byte

; (X) fixed lore MP address
org $C18389
lda $2195,X				; load lore MP cost

; (X) selecting a startup animation (only runs on magic Command)
org $C1ABA6
pha						; backup attack number
phy						; backup Y before subroutine
jsl SetAnimation()		; check if attack is a spell and increase X accordingly
ply						; restore Y
pla						; restore attack number
bcc $0B					; branch if spell is black/white/gray magic with X=0/2
inx #2 					; increase index
cmp #$51				; is this a summon?


; C2 Bank Changes

; (X) initialization of RAM (needs to include ED00-EFFF)
org $C223FF
ldx #$0A0E				; set number of bytes to clear
jsr InitRAM_C2()		; initialize RAM
nop #3					; do nothing

; (X) character spell list Data (written to RAM with MVN at C2/2424)
org $C22616
dw $208E				; character 1 esper/spell/lore list ($208E)
dw $21F2				; character 2 esper/spell/lore list ($21F2)
dw $2356				; character 3 esper/spell/lore list ($2356)
dw $EE00				; character 4 esper/spell/lore list ($EE00)

; (X) setting up magic/lore lists pre-battle
org $C2555C
MagicInit()
ldx #$3F				; load maximum spell index in X
sta $3034,X				; initialize RAM
skip 24
adc #$41				; offset to character spell/lore list where lore resides
sta $310F,Y				; save offset to locate lore in spell list
adc #$4A				; add enough to get the value to 8B, the first lore number
sta $ED40,Y				; save in list of known spells/lores
skip 6
.allspells
lda $3ED8,X				; get character properties ID
cmp #$FF				; is the slot empty?
bcs .nocharacter		; branch if actor slot empty
jsl PopulateMagic_C2()	; check character for known spells
.nocharacter
dex	#2					; decrease actor index
bpl .allspells			; branch if more actors to check
lda $1D54				; info from config screen
and #$07				; isolate magic order
tax						; transfer magic order ID to X
lda $C2574B,X			; load offset to start of black magic
sta $11					; save it
lda $C25751,X			; load offset to start of gray magic
sta $12					; save it
lda $C25757,X			; load offset to start of white magic
sta $13					; save it
lda #$36				; load offset to start of unallocated magic
sta $14					; save it
tdc						; clear A
tay						; clear Y
.spellorder
tya						; transfer spell offset to A
asl						; double it
tax						; transfer offset to X
jsl ListOrder_C2()		; set proper X for current spell
lda $ED00,Y				; get spell #
sta $3034,X				; save in correct location in spell list
iny						; increase spell index
cpy #$40				; have we reached the end of the spells?
bcc .spellorder			; branch if more spells to check
lda #$FF				; load null value
ldx #$3F				; load maximum spell index
.clearram
sta $ED00,X				; clear RAM
dex						; decrease spell index
bpl .clearram			; branch if more spells to clear
tdc						; clear A
tax						; transfer pull-from index to X
tay						; transfer save-to index to Y
.compressionbatch
lda $3034,X				; load spell in slot
inc						; spell number +1
bne .nocompress			; branch if there was a spell
lda $3035,X				; load spell in slot
inc						; spell number +1
bne .nocompress			; branch if there was a spell
lda $3036,X				; load spell in slot
inc						; spell number +1
beq .nextbatch			; branch if no spells in set of 3
.nocompress
lda $3034,X				; load spell
sta $ED00,Y				; save to condensed list
lda $3035,X				; load spell
sta $ED01,Y				; save to condensed list
lda $3036,X				; load spell
sta $ED02,Y				; save to condensed list
iny #3					; increase save-to index (if we saved spells)
.nextbatch
inx #3					; increase pull-from index
cpx #$3F				; have we checked the whole spell list (-1)?
bcc .compressionbatch	; branch if not
lda $3034,X				; load last spell to save, even if FF [null]
sta $ED00,Y				; save to condensed list
.spellindexing
lda $ED00,X				; load spell
cmp #$FF				; is it blank?
beq .nextindex			; go to next spell if so
tay						; transfer spell number to Y
txa						; transfer current index to A
inc						; increase index
sta $3084,Y				; store index as location to find spell in spell list
.nextindex
dex						; decrease index
bpl .spellindexing		; branch if there are more spells to check
rep #$10				; 16-bit X,Y
ldx #$0057				; load maximum spell/lore index
.definespell
tdc						; clear A
lda $ED00,X				; load spell
cmp #$FF				; is it blank?
beq .nextspell			; go to next spell if so
pha						; backup spell number
tay						; transfer spell number to Y
lda $3084,Y				; load location of spell in spell list
rep #$20				; 16-bit A
asl #2					; spell location x4
sep #$20				; 8-bit A
tay						; transfer offset to put spell in active spell list in Y
lda $01,S				; load spell number pushed to stack
cpx #$0040				; is this a lore?
bcc .savespellid		; branch branch if a standard spell
sbc #$8B				; subtract from lore spell number to get lore ID
.savespellid
sta $208E,Y				; save spell in character 1's list
sta $21F2,Y				; save spell in character 2's list
sta $2356,Y				; save spell in character 3's list
sta $EE00,Y				; save spell in character 4's list
pla						; restore spell number
jsr $5723				; get spell targetting/MP cost
sta $2090,Y				; save targeting in character 1's list
sta $21F4,Y				; save targeting in character 2's list
sta $2358,Y				; save targeting in character 3's list
sta $EE02,Y				; save targeting in character 4's list
xba						; transfer MP cost from B to A
cpx #$004E				; are we pointing at Step Mine's menu slot?
bne .savemp				; branch if not
lda $1864				; minutes portion of time played
cmp #$1E				; set Carry if >=30 minutes
lda $1863				; hours portion of time played
rol						; MP Cost = [hours * 2] + [minutes DIV 30]
.savemp
sta $2091,Y				; save MP Cost in character 1's list
sta $21F5,Y				; save MP Cost in character 2's list
sta $2359,Y				; save MP Cost in character 3's list
sta $EE03,Y				; save MP Cost in character 4's list
.nextspell
dex						; decrease index
bpl .definespell		; branch if more spells to load
plp						; restore processor status
rts						; exit 
nop #22

; (X) trim spell list for each character
org $C256CC
TrimmingSetup()
tax						; transfer character ID to X
lda SpellListTbl,X		; get spell list ID
cmp #$10				; does character have usable list?
bcs .checkspells		; branch if gogo-esque magic instead of list
iny #4					; set Y to proper offset to proper jump at C2/56F3
xba						; transfer spell list ID from A to B
lda #$23				; load multiplier to get starting address of list
jsr $4781				; multiplication function
rep #$21				; 16-bit A, clear Carry
adc #$1A89				; add product to #$1A89 to get character learned spells
sta $F0					; save address
sep #$20				; 8-bit A
.checkspells
tyx						; transfer Y set above to X for jump at C2/56F3
ldy #$0160				; load index to spell locations in list
.loop
tdc						; clear A
lda ($F2),Y				; load active spell list at position Y
cmp #$FF				; is it empty?
beq $1B					; branch if no spell available in this menu slot
skip 7
bne .loop				; point to next menu slot, and loop

; byte order for table below:
; Healing, Attack, Effect (HAE)
; Healing, Effect, Attack (HEA)
; Attack, Effect, Healing (AEH)
; Attack, Healing, Effect (AHE)
; Effect, Healing, Attack (EHA)
; Effect, Attack, Healing (EAH)

; (X) first slot for black magic depending on config (pulled from C2/559E)
org $C2574B
db $09,$1E,$00,$00,$1E,$15
; (X) first slot for gray magic depending on config (pulled from C2/55A4)
org $C25751
db $21,$09,$18,$21,$00,$00
; (X) first slot for white magic depending on config (pulled from C2/55AA)
org $C25757
db $00,$00,$2D,$18,$15,$2D

; (X) pointers for how to trim spell list (from C2/56F3)
org $C2575D
dw $67EF				; gogo-esque magic
dw $67E4				; no spells usable
dw $67C0				; normal magic trimming 

; (X) set availability of spells
org $C25790
jsr SetAvailability()	; set carry if spell should be unavailable
skip 3
ldy #$0057				; load index for maximum number of spells/lores in list
skip 4
jsr SetAvailability()	; set carry if spell should be unavailable

; (X) post battle script
PostBattle()
org $C25E19
beq $49					; branch if character dead or otherwise empty
org $C25E59
jsr APCheck()			; check for equipped espers and sync F0 and F1 if so
ldx $3010,Y				; get offset to character info block
phy						; backup Y
jsr CursedShield()		; Cursed Shield check
ply						; restore Y
dey #2					; decrease actor index
bpl $AB					; branch if there are more actors to check
lda $F1					; load F1
and $F0					; compare to F0
beq .levelandmagic		; branch if they aren't the same
lda $FB					; magic points gained from battle
beq .levelandmagic		; branch if no magic points
sta $2F35				; store as parameter for message function
stz $2F36				; clear parameter
stz $2F37				; clear parameter
lda #$35				; load message type
jsr $5FD4				; move to C1 to display messages
.levelandmagic
ldy #$0006				; load actor index
.loop
lda $3018,Y				; load character ID
bit $3A74				; is someone in this slot?
beq .nextactor			; branch if not
ldx $3010,Y				; get offset to character info block
tya						; transfer actor ID to A
lsr						; double it
sta $2F38				; store as C1 parameter for level up code
lda #$2E				; message type
sta $F2					; store message type for C2/60A8
ldx $3ED8,Y				; get character ID
sep #$10				; set 8-bit X,Y
lda SpellListTbl,X		; load spell list ID
rep #$10				; set 16-bit X,Y
pha						; backup spell list ID
jsr ListAdress()		; stores address for spells known by character in $F4
ldx $3010,Y				; get offset to character info block
jsr $606D				; character level up and display learned magic from level up
pla						; restore spell list ID
bmi .nextactor			; branch if no list
lda $161E,X				; esper equipped
bmi .nextactor			; branch if no esper equipped
phy						; backup actor ID
jsr EsperAP()			; learn spells taught by esper and display messages
ply						; restore actor ID
.nextactor
dey #2 					; decrease index
bpl .loop				; branch if there are more characters to check

; (X) Cursed Shield check (from C2/5E60)
org $C25FEF
CursedShield()
phx						; backup X
ldy #$0006				; check all equipment and relic slots
.loop
lda $161F,X				; item equipped, X determines slot to check
cmp #$FF				; is it empty?
beq .nextitem			; branch if no item equipped
skip 18
.nextitem
inx						; increase index
dey						; decrease slots left to check
bne .loop				; branch if more slots to check
plx						; restore X
rts						; exit 

; (X) learn Spells via esper (from C2/5EB5)
org $C26012
EsperAP()
clc						; clear carry
pha						; backup A
tdc						; clear A,B
pla						; restore A
tay						; transfer esper ID to Y
lda ($F4),Y				; load AP for curent esper
bmi .exit				; exit if already mastered
adc $FB					; add AP gained from battle
bcc .apsave				; branch if AP didn't exceed FF
lda #$FF				; load maximum value
.apsave
sta ($F4),Y				; store max value if somehow exceeded
tya						; transfer esper number back to A
jsr $6293				; multiply A by #$0B and store in X
ldy #$0005				; do for each spell taught by esper
.loop
tdc						; clear A
lda $D86E01,X			; spell taught
cmp #$FF				; is it there a spell in this slot?
beq .nextspell			; branch if no spell taught
jsl LearnMagic_C2()		; check if magic is ready to be learned
.nextspell
inx #2					; increase index
dey						; decrease number of spells to check for
bne .loop				; branch if more spells left to check
.exit
rts						; exit 

; <> long access into display function (from F3/036F)
org $C2603D
MessageAccess()
jsr $5FD4				; display messages
rtl						; exit
nop #5

; <> check for equipped espers and sync F0 and F1 if so (from C2/5E59)
org $C26046
APCheck()
ldx $3010,Y				; get offset to character info block
lda $161E,X				; esper equipped
bmi .exit				; branch if no esper equipped
lda $F1					; load $F1
tsb $F0					; sync with F0 to indicate display AP message
.exit
rts						; exit

; (X) set carry if spell should be unavailable (from C2/5790, C2/579D)
org $C26053
SetAvailability()
lda $0000,X				; get spell # from menu
cmp #$FF				; is the slot blank?
bcs .unavailable		; branch if undefined
xba						; transfer spell number from A to B
lda $EF					; character status byte
bpl .checkmp			; branch if character not an Imp
xba						; transfer spell number from B to A
cmp #$23				; is this the Imp spell?
beq .checkmp			; branch if spell is Imp
.unavailable
sec						; otherwise spell will be unavailable
rts						; exit 
.checkmp
lda $0003,X				; get spell's MP cost from menu data
cmp $3A4C				; compare to Caster MP + 1, capped at 255
rts						; exit 

; <> initialize RAM (from C2/2402)
org $C26133
InitRAM_C2()
sta $2000,X				; save FF
sta $2A10,X				; save FF
cpx #$0400				; compare index to #$400
bcs .exit				; skip next if #$400 or higher
sta $ED00,X				; save FF
.exit
rts						; exit
nop #12

; (X) Terra and Celes natural magic learning at level up
org $C2620E
phx						; backup index to natural magic list
jsl LearnSpell_C2()		; learn spell		 
plx						; restore index to natural magic list
nop #5

; (X) stores address for esper AP lists $F4 (from C2/5EA3)
org $C26283
ListAdress()
skip 2
lda #$23				; load multiplier to get to spell list

; <> check to see if a spell is available in magic list (from C2/56F3)
org !freespaceC2
TrimSpells()
cpy #$0104				; is this a lore? (from C2/56F3, X=4)
bcs .getmp				; branch if we're pointing to a lore slot
phx						; backup X
phy						; backup Y
jsl FindSpellIndex()	; get proper index for spell number
cmp #$40				; is spell actually supposed to be a spell
bcs .blankspell			; branch if spell shouldn't exist (this should never run)
asl						; double spell index
tax						; transfer index to X
lda SpellByteTbl,X		; load byte to check in spell list
tay						; transfer byte to check in Y
lda SpellBitTbl,X		; load bit to check in spell list
sta $12					; save bit to check
lda ($F0),Y				; load spell list byte for spell
bit $12					; check if spell is known
bne .savespell			; known
ply						; restore Y
plx						; restore X
.blankspell
tdc						; clear A (from C2/56F3, X=2)
sta ($F4),Y				; save 0 as MP cost
dec						; set A to #$FF
sta ($F2),Y				; save FFh [null] as spell #
jmp $56F6				; reenter our 88-slot loop
.savespell
ply						; restore Y
plx						; restore X
cpy #$0104				; lore checked again for gogo-esque magic (from C2/56F3, X=0)
bcs .getmp				; branch if we're pointing to a lore slot
inc $F6					; increase number of spells known for character
.getmp
lda ($F4),Y				; get spell's MP cost from menu
jsr $5736				; change it if gold Hairpin or Economizer equipped
sta ($F4),Y				; save updated MP cost
jmp $56F6				; reenter our 88-slot loop


; C3 Bank Changes

; (X) determine whether actor can use magic
org $C30D37
EnableMagic()
bne .allow				; allow if espers obtained
ldx $67					; actor's address
skip 4
tax 					; transfer character number to X
lda SpellListTbl,X		; load character spell list ID
bmi .allow				; Allow if so
sta $4202				; set multiplicand
lda #$23				; Spell list length
sta $4203				; set multiplier
nop #3					; wait
ldy #$0008				; bytes to check (8)
ldx $4216				; Index product
.loop
lda $1A89,X				; Spell mastery
bne .allow				; Allow if not empty
inx			    		; Point to next
dey			    		; One less left
bne .loop				; Loop till last
clc			    		; Access: No
rts						; exit
.allow
sec			    		; Access: Yes
rts						; exit

; (X) create scrollbar for magic menu
org $C32137
lda #$0400				; V-Speed: 4.00 px

; (X) switch to magic menu, create portrait, draw spells and "MP…"
org $C32158
lda #$18				; Top row: Sleep's

; (X) build magic list based on Mag.Order
org $C34F22
BuildList_C3()
ldx #$0040				; Spells: 64
skip 15
sep #$10				; 8-bit X,Y
tax						; set magic order as index
lda $C2574B,X			; load offset to start of black magic
sta $E1					; save it
lda $C25751,X			; load offset to start of gray magic
sta $E2					; save it
lda $C25757,X			; load offset to start of white magic
sta $E3					; save it
lda #$36				; load offset to start of unallocated magic
sta $E4					; save it
tdc						; clear A
tay						; clear Y
.loop
tya						; transfer spell index to A
asl						; double it
tax						; transfer doubled index to X
jsl ListOrder_C3()		; set proper index for current spell
phx						; backup doubled index
tyx						; transfer spell index from Y to X
lda SpellTbl,X			; get actual spell #
plx						; restore doubled index
sta $7E9D89,X			; add spell to list
iny						; increase spell index
cpy #$40				; have we reached the end of the list?
bcc .loop				; branch if more spells to add to list
rep #$10				; 16-bit X,Y
rts						; exit
fillbyte $ff : fill 29

; (X) draw a row of two spells in magic menu
org $C34F9E
jsr SourceMagicMenu()	; define source
skip 8
jsr SourceMagicMenu()	; define source

; (X) draw text in spell slot of magic menu
org $C34FE4
jsr MasteryEntry()		; Spell mastery

; (X) Fork: draw spell plus percentage
org $C35045
jsr MasteryEntry()		; Spell mastery
skip 19
jsr MasteryEntry()		; Spell mastery

; (X) clearing space from where mastery code used to reside
org $C350A2
fillbyte $ff : fill 30

; (X) Fork: test all members for gogo (from C3/F332)
org $C350C0
GogoMagic_C3()
stz $F3					; Member slot: 1
.loop
tdc						; clear A
lda $F3					; Tested member
cmp $28					; gogo?
beq .nextactor			; Skip if so
asl A					; Double it
tax						; Index it
ldy $6D,X				; actor's address
beq .nextactor			; Skip if nobody
lda $0000,Y				; character ID
tax						; transfer character ID from A to X
lda SpellListTbl,X			; get spell list ID
cmp #$10				; gogo-esque?
bcs .nextactor			; Skip if so
jsr Mastery()			; actor's mastery
cmp #$FF				; Fully learned?
beq .exit				; Exit if so
.nextactor
inc $F3					; Member slot +1
lda $F3					; Members done
cmp #$04				; Done all 4?
bne .loop				; Loop if not
tdc						; Mastery: 0
.exit
rts						; exit

; (X) draw spell's mastery percentage for esper data menu
org $C35A9C
jsr MasteryEntry()		; Spell mastery

; (X) draw spell's name and learning rate
org $C35AED
jsr SourceEsperMenu()	; define source

; (X) Fork: magic effect descriptions
org $C35BE3
ldx #$0400				; F3/0400
STX $E7					; set ptr loc LBs
ldx #$0600				; F3/0600
STX $EB					; set text loc LBs
lda #$F3				; Bank: F3
sta $E9					; set ptr loc HB
lda #$F3				; Bank: F3
sta $ED					; set text loc HB
rts						; exit

; <> set source for loading magic name (from C3/5AED, C3/4F9E, C3/4FA9)
org !freespaceC3
SourceEsperMenu()
lda $E1					; Spell (from esper menu: C3/5AED)
bra $03					; skip finding spell from magic menu
SourceMagicMenu()
jsr $50EC				; Spell	(from magic menu: C3/4F9E, C3/4FA9)
cmp #$36				; Standard magic set?
bcs .nonstandard		; branch if not
jsr $4FB5				; define source
rts						; exit
.nonstandard
cmp #$51				; Is it an esper?
bcs .nonesper			; branch if not
ldy #$0008				; Letters: 8
sty $EB					; set src size
ldy #$F531				; E6/F531
sty $EF					; set src LBs
lda #$E6				; Bank: E6
sta $F1					; set src HB
rts						; exit
.nonesper
ldy #$000A				; Letters: 10
sty $EB					; set src size
ldy #$F48F				; E6/F48F
sty $EF					; set src LBs
lda #$E6				; Bank: E6
sta $F1					; set src HB
rts						; exit

; <> get spell's mastery percentage (from C3/4FE4, C3/5045, C3/505B, C3/50DB, C3/5A9C)
org !freespaceC3+49
MasteryEntry()
sta $E1					; save spell (from C3/4FE4, C3/5045, C3/505B, C3/5A9C)
jsr $4EDD				; define Y
lda $0000,Y				; get character ID
tax						; transfer it to X
lda SpellListTbl,X		; get spell list ID
cmp #$10				; gogo-esque?
bcc Mastery()			; branch if not
jmp GogoMagic_C3()		; jump to check all for gogo-esque magic
Mastery()				; for re-entry from gogo code
sta $4202				; set multiplicand (from C3/50DB)
lda #$23				; spell list size
sta $4203				; set multiplier
tdc						; clear A
rep #$21				; 16-bit A
lda #$1A6E				; load starting address for all esper AP lists
adc $4216				; add product
sta $FC					; save esper AP bytes address for this list
adc #$001B				; add to get start of learned spell bits
sta $FE					; save spell learned bits address
sep #$30				; 8-bit A,X,Y
lda $E1					; load spell number
jsl FindSpellIndex()	; find index for spell number
asl						; double it
tax						; transfer doubled index to X
phy						; backup Y
lda SpellByteTbl,X		; load byte to check in spell list
tay						; transfer byte to check to Y
lda SpellBitTbl,X		; load bit to check in spell list
sta $F7					; save bit to check for spell
lda ($FE),Y				; load byte containing spell we're checking
ply						; restore Y
rep #$10				; 16-bit X,Y
bit $F7					; is the spell known?
beq .checkpercent		; branch if spell unknown
lda #$FF				; set FF to indicate spell mastered
rts						; exit
.checkpercent
tdc			    		; mastery: 0
phy						; backup Y
tax						; clear X (spell index)
tay						; clear Y (esper index)
STX $F8					; initialize cumulative total
.esperloop
lda #$05				; load counter for when to go to next esper
sta $FA					; store counter for when to increase the esper count
.spellloop
lda $D86E01,X			; check spell at index X
cmp $E1					; is it the spell we're checking for?
bne .nextspell			; branch if it isn't
lda $D86E00,X			; spell learn rate
sta $4202				; set multiplicand
lda ($FC),Y				; load AP for curent esper
sta $4203				; set multiplier
nop #2					; wait for processing
rep #$21				; 16-bit A, clear carry
lda $F8					; load Current AP sum
adc $4216				; add product
sta $F8					; add to cumulative total
cmp #$0064				; have we reached 100%?
bcs .badram				; branch if we've reached 100%
sep #$20				; 8-bit A
.nextspell
inx #2 					; increase spell index
dec $FA					; decrement spells-per-esper counter
bne .spellloop			; check next spell taught
inx						; skips esper bonus
iny						; increase esper index
cpy #$001B				; are there more espers to check?
bcc .esperloop			; branch if there are more espers to check
lda $F8					; percentage learned
ply						; restore Y
rts						; exit
.badram					; will never run from a new game
sep #$20				; 8-bit A
lda #$63				; loads 99% if spell not known but is above 100%
ply						; restore Y
rts						; exit


; F3 Functions

; <> reverse spell lookup (in=Spell number, out=spell-in-menu index) (from C0/D643, C2/67C7, C3/F351, F3/0248, F3/0337) 
org !freespaceF3
FindSpellIndex()
php						; backup processor
sep #$30				; set 8-bit A,X,Y
phx						; backup X
pha						; backup spell number onto the stack
ldx #$3F				; load highest possible index
.loop
lda SpellTbl,X			; load spell for current index
cmp $01,S				; check against stored spell number
beq	.foundspell			; branch if we found it
dex						; reduce index
bpl .loop				; check next spell
.foundspell
pla						; remove backup from stack
txa						; Transfers offset to A, FF stored in case not found
plx						; restore X
plp						; restore processor
rtl						; exit

; <> backup availablilty for text palette selection (from C1/659B)
org !freespaceF3+23
BackupAvailability()
lda ($4F)				; load spell in slot
sta $2C					; store spell for use in name function
xba						; load availability of spell into A from B
sta $1F					; set availability for later check
xba						; transfer spell back into A from B
rtl						; exit

; <> set name length and multiplier for esper names and onward (from C1/65B6, C1/65D2)
org !freespaceF3+32
TrunkName()
sta $2E					; store current value as multiplier
pha						; backup multiplier for discovering name location
lda $7BC2				; load menu identifier
cmp #$0D				; #$0D used exclusively in magic menu
beq .magicmenu			; branch if in magic menu
cmp #$0E				; #$0E used exclusively in magic menu
beq .magicmenu			; branch if in magic menu
pla						; restore multiplier if not in magic menu
sta $40					; store as number of letters to process
rtl						; exit
.magicmenu
lda #$07				; load #$07
sta $40					; store as number of letters to process
pla						; restore multiplier for discovering name location
rtl						; exit

; <> esper name loading (from C1/65DB)
org !freespaceF3+56
EsperName_C1()
lda $7BC2				; load menu identifier
cmp #$0D				; #$0D used exclusively in magic menu
beq .magicmenu			; branch if in magic menu
cmp #$0E				; #$0E used exclusively in magic menu
beq .magicmenu			; branch if in magic menu
lda $E6F6E1,X			; load esper name X for esper menu
rtl						; exit
.magicmenu
lda $1F					; load backup of availability (from F3/01FC)
xba						; transfer into B from A
lda $E6F531,X			; load esper name X for magic menu
rtl						; exit

; <> skean and onward name loading (from C1/65BF)
org !freespaceF3+80
SkeanName_C1()
lda $7BC2				; load menu identifier
cmp #$0D				; #$0D used exclusively in magic menu
beq .magicmenu			; branch if in magic menu
cmp #$0E				; #$0E used exclusively in magic menu
beq .magicmenu			; branch if in magic menu
lda $E6F7B9,X			; load skean attack name X
rtl						; exit
.magicmenu
lda $1F					; load backup of availability (from F3/01FC)
xba						; transfer into B from A
lda $E6F48F,X			; load skean attack name X for magic menu
rtl						; exit

; <> check if attack is a spell and set X accordingly (from C1/ABA8)
; (set X to 0/2 for B/W animation, set Carry if neither)
org !freespaceF3+104
SetAnimation()
jsl FindSpellIndex()	; find index for spell number
cmp #$FF				; was the spell in the list?
beq	.nonmagic			; branch if spell wasn't listed
asl						; double index
tax						; transfer offset to X
lda SpellBitTbl,X		; get bit to check
sta $10					; store for test
lda SpellByteTbl,X		; get byte offset
tax						; transfer byte offset to X
lda BlackBitmask,X		; get black magic list byte
bit $10					; check test bit against black magic bitmask
beq .notblack			; branch if not black magic
ldx #$0000				; set 00 as X for black magic animation
rtl						; exit
.notblack
lda GrayBitmask,X		; get gray magic list byte
bit $10					; check test bit against gray magic bitmask
bne .graywhite			; branch if gray magic
lda WhiteBitmask,X		; get white magic list byte
bit $10					; check test bit against white magic bitmask
bne .graywhite			; branch if white magic
.nonmagic
sec						; set carry if not in any list for no magic animation
.graywhite
ldx #$0002				; load 02 as X for white/gray magic animation
rtl						; exit

; <> check first letter, skipping magic symbols (from C1/5FDD)
org !freespaceF3+158
inx						; increase X if last checked letter was a magic symbol
dec $616D				; decrease count of letters to check
SkipSymbol_1()
lda $E6F7B9,X			; load skean attack name X (C1/5FDD joins here)
cmp #$E8				; compare to black magic symbol
bcc .exit				; exit if lower valued letter
cmp #$EB				; compare to white magic symbol
bcc $F0					; skip letter if we are on a magic symbol
.exit
rtl						; exit

; <> check first letter, skipping magic symbols (from C1/6AED)
org !freespaceF3+175
inx						; increase X if last checked letter was a magic symbol
dec $10					; decrease count of letters to check
SkipSymbol_2()
lda $E6F7B9,X			; load skean attack name X (C1/6AED joins here)
cmp #$E8				; compare to black magic symbol
bcc .exit				; exit if lower valued letter
cmp #$EB				; compare to white magic symbol
bcc $F1					; skip letter if we are on a magic symbol
.exit
rtl						; exit

; <> check character spell list for spells and save to list of known spells (from C2/558C)
org !freespaceF3+191
PopulateMagic_C2()
phx						; backup X 
tax						; transfer character ID to X
lda SpellListTbl,X		; get spell list ID
cmp #$10				; if no list
bcs .exit				; plx and return
sta $004202				; store multiplicand
lda #$23				; load spell list multiplier
sta $004203				; store multiplier
rep #$21				; set 16-bit A, clear carry
lda #$1A89				; load starting address for all magic lists
nop	#2					; wait for processing to finish
adc $004216				; add offset to magic list for correct address
sta $F0					; save in $F0
sep #$20				; 8-bit A
ldx #$3F				; set index to maximum spell ID
ldy #$07				; byte counter
.byteloop
lda #$07				; bit counter
sta $10					; save bit counter in $10
lda ($F0),Y				; load magic list address at byte counter index
.bitloop
rol						; shift current first bit into carry
bcc .gotonext			; if no spell set at bit, check next bit
pha						; backup spell list byte in current state
lda SpellTbl,X			; load actual spell number
sta $ED00,X				; stores spell as a spell known by someone in the party
pla						; restore spell list byte for continued checking
.gotonext
dex						; decrease spell index
dec $10					; decrease bit counter
bpl .bitloop			; check next spell in byte
dey						; decrease Y (byte counter)
bpl .byteloop			; check next byte in list
.exit
plx						; restore X
rtl						; exit

; <> check if magic is ready to be learned (from C2/6033)
org !freespaceF3+259
LearnMagic_C2()
phx						; backup X
phy						; backup Y
sta $10					; save spell number for checking
ldx #$0000				; clear X as spell index
ldy #$0000				; clear Y for esper counter
STX $12					; initalize cumulative total
.checkesper
lda #$05				; load per-esper counter
sta $11					; store as counter for when to increase the esper count
.checkspell
lda $D86E01,X			; check current spell
cmp $10					; is it the spell we're checking for?
bne .nextspell			; branch if it isn't
lda $D86E00,X			; Spell learn rate
sta $004202				; store multiplicand
lda ($F4),Y				; load AP for Curent esper
sta $004203				; store multiplier
rep #$21				; set 16-bit A, clear carry
lda $12					; load current total
nop	#2					; wait for processing to finish
adc $004216				; add product to cumulative total
sta $12					; update cumulative value
cmp #$0064				; have we earned enough AP to learn spell?
bcs .learnspell			; branch if we've reached 100%
sep #$20				; 8-bit A
.nextspell
inx #2					; increase index
dec $11					; decrease counter for when to move to next esper
bne .checkspell			; check next spell taught
inx						; skips esper bonus
iny						; next esper number
cpy #$001B				; have we checked all espers?
bcc .checkesper			; branch if there are more espers to check
bra .exit				; if we are done, exit
.learnspell
sep #$20				; 8-bit A
lda $10					; load spell number to pass into subroutine
jsl LearnSpell_C2()		; learn spell and display message
.exit
ply						; restore Y
plx						; restore X
rtl						; exit

; <> learn Spell (from C2/620F, F3/032F)
org !freespaceF3+342
LearnSpell_C2()
php						; backup processor status
jsl $F301E0				; reverse spell lookup (find index for spell number)
sta $10					; save spell number for checking
asl						; double spell number
sep #$10				; 8-bit X,Y
tax						; transfer offset to X
rep #$20				; 16-bit A
lda $F4					; load AP list offset
adc #$001B				; add offset to get to beginning of learned spell bits
sta $14					; store offset to spell bits
sep #$20				; 8-bit A
lda SpellBitTbl,X		; load bit to check for spell
sta $16					; store bit to check against
lda SpellByteTbl,X		; load byte offset for spell
tay						; set byte offset for spell bits
lda ($14),Y				; load learned spell byte
bit $16					; check bit for spell
bne .exit				; branch if already known
lda ($14),Y				; load learned spell byte
ORA $16					; set bit to learn the spell
sta ($14),Y				; save updated byte to learn the spell
lda $10					; load spell index
tax						; transfer spell index to X
lda SpellTbl,X			; get actual attack number
sta $2F35				; store attack ID for display
lda #$32				; indicator for what kind of message
jsl MessageAccess()		; display messages
.exit
plp						; restore processor status
rtl						; exit

; <> get list order offset for current spell and put in X (from C2/55BA)
org !freespaceF3+405
ListOrder_C2()
lda SpellBitTbl,X		; get bit to check
sta $10					; save bit to check
lda SpellByteTbl,X		; get byte offset
tax						; transfer byte offset to X
lda BlackBitmask,X		; get black magic list byte
bit $10					; check if spell is black magic
beq .notblack			; branch if not black magic
ldx $11					; load current black magic slot
inc $11					; set next black magic spell slot
rtl						; exit
.notblack
lda GrayBitmask,X		; get gray magic list byte
bit $10					; check if spell is gray magic
beq .notgray			; branch if not gray magic
ldx $12					; load current gray magic slot
inc $12					; set next gray magic slot
rtl						; exit
.notgray
lda WhiteBitmask,X		; get white magic list byte
bit $10					; check if spell is white magic
beq .notwhite			; branch if not white magic
ldx $13					; load current white magic slot
inc $13					; set next white magic slot
rtl						; exit
.notwhite
ldx $14					; load current unallocated magic slot
inc $14					; set next unallocated magic slot
rtl						; exit

; <> get list order offset for current spell and put in X (from C3/4F52)
org !freespaceF3+460
ListOrder_C3()
lda SpellBitTbl,X		; get bit to check
sta $E0					; save bit to check
lda SpellByteTbl,X		; get byte offset
tax						; transfer byte offset to X
lda BlackBitmask,X		; get black magic list byte
bit $E0					; check if spell is black magic
beq .notblack			; branch if not black magic
ldx $E1					; load current black magic slot
inc $E1					; set next black magic spell slot
rtl						; exit
.notblack
lda GrayBitmask,X		; get gray magic list byte
bit $E0					; check if spell is gray magic
beq .notgray			; branch if not gray magic
ldx $E2					; load current gray magic slot
inc $E2					; set next gray magic slot
rtl						; exit
.notgray
lda WhiteBitmask,X		; get white magic list byte
bit $E0					; check if spell is white magic
beq .notwhite			; branch if not white magic
ldx $E3					; get current white magic slot
inc $E3					; set next white magic slot
rtl						; exit
.notwhite
ldx $E4					; get current unallocated magic slot
inc $E4					; set next unallocated magic slot
rtl						; exit